<?php
function recognitions_admin_page() {
	wp_enqueue_script('wp-api');
	wp_enqueue_style('recognitions-admin', plugin_dir_url(__FILE__) . 'admin.css');
	require 'template.php';
}

add_action('admin_menu', 'register_values_board_admin_page');

function register_values_board_admin_page() {
	add_menu_page('recognitions', 'Values Board', 'administrator', 'recognitions-admin-page', 'recognitions_admin_page');
}

// Messages

if (!function_exists('acf_add_local_field_group')):
	function acf_missing_error_notice() {
		?>
		<div class="error notice">
			<p><?php _e('The Values Board plugin requires the <a target="_blank" href="https://wordpress.org/plugins/advanced-custom-fields/">ACF plugin</a> to function.', 'values_board'); ?></p>
		</div>
		<?php
	}
	add_action('admin_notices', 'acf_missing_error_notice');
endif;

$options = get_option('values_board_options');
if (!$options || !$options['values_board_field_values']):
	function values_missing_error_notice() {
		?>
		<div class="error notice">
			<p><?php _e('You need to populate some values for the <a href="/wp-admin/admin.php?page=values_board">Values Board plugin</a>.', 'values_board'); ?></p>
		</div>
		<?php
	}
	add_action('admin_notices', 'values_missing_error_notice');
endif;

$users = get_users(array(
	'role' => 'author'
));
if (!$users || !count($users)):
	function users_missing_error_notice() {
		?>
		<div class="error notice">
			<p><?php _e('You need to populate some <a href="/wp-admin/users.php">users</a> with the Author role for the Values Board plugin.', 'values_board'); ?></p>
		</div>
		<?php
	}
	add_action('admin_notices', 'users_missing_error_notice');
endif;

?>