<div class="wrap">
	<h1>Recognitions Admin</h1>
	<br>
</div>

<div class="controls_header">
	<select id="year_filter">
		<?php
		$years = array(Date('Y'), Date('Y')-1);
		foreach ($years as $i => $year) {
		    echo '<option value="' . $year . '">' . $year . '</option>';
		} ?>
	</select>
	<select id="month_filter">
		<?php
		$months = array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');
		foreach ($months as $i => $month) {
		    echo '<option ' . (Date('F') == $month ? 'selected="selected"' : '') . ' value="' . $month . '">' . $month . '</option>';
		} ?>
	</select>
	<button id="archive_month">Archive Month</button>
</div>

<br>

<div class="recognitions">

</div>

<script>
	jQuery(($) => {
		var recognitionsWrapper = $('.recognitions');
		var loadedRecognitions = null;
		var currentMonth = null;
		var currentYear = <?php echo Date('Y'); ?>;

		var loadRecognitions = (year, month) => {
			recognitionsWrapper.addClass('loading');

			$.get('/values-board/archives?month=' + month + '&year=' + year, (response) => {
				loadedRecognitions = $.parseJSON(response);
				populateRecognitions(loadedRecognitions);
				recognitionsWrapper.removeClass('loading');
			});
		}

		// Debug
		// var posts = new wp.api.collections.Posts();
		// posts.fetch({data: {per_page: 100, status: 'any', filter: {'orderby': 'title', 'order': 'DESC'}}}).done(() => {
		// 	console.log(posts);
		// 	var loadedPosts = _.map(posts.models, post => post.attributes);
		// });

		var populateRecognitions = loadedRecognitions => {
			recognitionsWrapper.html('');

			loadedRecognitions.map(recognition => {
				var recognitionElement = $('<a class="recognition"></a>');
				recognitionElement.addClass(recognition.post_status == 'draft' ? 'archived' : '');
				recognitionElement.attr('href', `/wp-admin/post.php?post=${recognition.ID}&action=edit`);
				recognitionElement.attr('data-recognition-id', recognition.ID);
				var note = recognition.acf.note;
				var values = `<h5>${recognition.acf.value.split(',').join(', ')}</h5>`
				var publishButton = '<button class="publish">Publish</button>';
				recognitionElement.append(publishButton);
				recognitionElement.append(note);
				recognitionElement.append(values);
				recognitionElement.appendTo(recognitionsWrapper);
			});
		}

		var publishRecognition = (id) => {
			$.post('/values-board/toggle-status?status=publish&id=' + id, (response) => {
				$(`.recognition[data-recognition-id=${id}]`).removeClass('archived');
			});
		}

		var archiveMonth = () => {
			loadedRecognitions.map(loadedRecognition => {
				$.post('/values-board/toggle-status?status=draft&id=' + loadedRecognition.ID, (response) => {
					$(`.recognition[data-recognition-id=${loadedRecognition.ID}]`).addClass('archived');
				});
			});
		}

		$('.recognitions').on('click', 'button', (e) => {
			var clicked = $(e.target);
			var id = clicked.parent().attr('data-recognition-id');
			publishRecognition(id);
			return false;
		});

		$('#year_filter').change(e => {
			currentYear = $(e.target).val();
			loadRecognitions(currentYear, currentMonth);
		});

		$('#month_filter').change(e => {
			currentMonth = $(e.target).val();
			loadRecognitions(currentYear, currentMonth);
		}).trigger('change');

		$('#archive_month').click(e => {
			archiveMonth();
		});

	})
</script>