var webpack = require('webpack');
var path = require('path');

module.exports = {
	context: path.join(__dirname, 'app'),
	entry: path.join(__dirname, 'app', 'entry.jsx'),
	output: {
		path: path.resolve(__dirname, "bin"),
		filename: 'app.bundle.js'
	},
	module: {
		rules: [
			{
				test: /\.(js|jsx)$/,
				exclude: /node_modules/,
				use: ['babel-loader']
			}
		]
	},
	resolve: {
		extensions: ['*', '.js', '.jsx']
	},
	plugins: [
		new webpack.ProvidePlugin({
			React: 'react',
			ReactDOM: 'react-dom',
			$: "jquery",
			jQuery: "jquery"
		})
	],
	watch: true
};
