class Add extends React.Component {
	constructor(props) {
		super(props);
		this.state = {show: false};
		this.state.recognition = this.getEmptyRecognition();
	}

	getEmptyRecognition() {
		return {
			title: '',
			note: '',
			value: [],
			who: ''
		}
	}

	componentWillMount() {
		this.addAction = this.addAction.bind(this);
		emitter.on('add', this.addAction);
	}

	componentDidMount() {
	}

	componentWillUnmount() {
		emitter.removeListener('add', this.addAction);
	}

	addAction(userData) {
		this.state.recognition = this.getEmptyRecognition();
		this.state.recognition.who = userData.ID;
		this.toggle();
	}

	toggle() {
		this.state.show = !this.state.show;
		let newState = deepCopy(this.state);
		this.setState(newState);

		if (this.state.show) {
			setTimeout(function() {
				$('input[name="note"]').focus();
			});
		} else {
			$('input[name="note"]').val('');
		}
	}

	setValue(field, e) {
		let newState = _.clone(this.state);

		let value = e.target.value;

		if (field == 'value') {
			if (_.includes(newState.recognition.value, value)) {
				newState.recognition.value = _.filter(newState.recognition.value, function(existingValue) {
					return existingValue != value;
				});
			} else {
				newState.recognition.value.push(value);
			}
		} else {
			newState.recognition[field] = value;
		}

		this.setState(newState);
	}

	handleSubmit(e) {
		e.preventDefault();

		let recognitionData = {
			title: this.state.recognition.note,
			fields: {
				note: this.state.recognition.note,
				who: this.state.recognition.who,
				value: this.state.recognition.value
			}
		}

		dispatcher.dispatch({type: 'create-recognition', recognitionData: recognitionData});

		this.state.recognition = this.getEmptyRecognition();
		this.toggle();
		$(window).focus();
	}

	render() {
		let submitButton = <input type="submit" value="CREATE" />;
		if (this.state.editedId)
			submitButton = <input type="submit" value="SAVE" />;

		let values = JSON.parse($('#values_choices').html());
		let valuesMap = [];

		_.each(values, function (value, key) {
			valuesMap.push(
				<option key={key} name={key} value={value}>{value}</option>
			);
		});

		const user = _.find(this.props.users, (user) => {
			return user.ID == this.state.recognition.who
		});

		let who = '';
		if (this.state.recognition.who)
			who = <img src={user.url} />

		return (
			<div id="add" className={this.state.show ? 'show' : ''}>
				{who}
				<form onSubmit={this.handleSubmit.bind(this)}>
					<label htmlFor="note">Note</label>
					<input type="text" id="note" onChange={this.setValue.bind(this, 'note')} value={this.state.recognition.name} name="note" />

					<label htmlFor="value">Values</label>
					<select multiple id="value" onChange={this.setValue.bind(this, 'value')} value={this.state.recognition.value} name="value">
						{_.map(valuesMap, function(value) {
							return value;
						})}
					</select>

					<br />

					{submitButton}
				</form>
			</div>
		);
	}
};

export default Add;