import HTML5Backend from 'react-dnd-html5-backend';

import User from './user.jsx';
import Add from './add.jsx';

export default class App extends React.Component {
	constructor(props) {
		super(props);
		this.state = {data: {users: null, recognitions: null}};
	}

	componentWillMount() {
		this.dataReceived = this.dataReceived.bind(this);
		emitter.on('data-received', this.dataReceived);
	}

	componentDidMount() {
		dispatcher.dispatch({type: 'get-data'});
	}

	componentWillUnmount() {
		emitter.removeListener('data-received', this.dataReceived);
	}

	dataReceived(data) {
		this.setState({data: data});
	}

	render() {
		const {users, recognitions} = this.state.data;

		if (!users)
			return null;

		return (
			<section className="app">
				<h1><img src="/wp-content/plugins/values_board/page/css/images/logo.svg" /> Gold Star Board</h1>
				<Add users={users} />
				{users.map(function (user, i) {
					return <User userData={user} recognitions={recognitions} key={i} />
				}.bind(this))}
			</section>
		);
	}
};