import Recognitions from './recognitions.jsx';

export default class User extends React.Component {
	constructor(props) {
		super(props);
		this.state = {};

		this.addRecognition = this.addRecognition.bind(this);
	}

	addRecognition() {
		emitter.emit('add', this.props.userData);
	}

	render() {
		const {userData, recognitions} = this.props;

		let userRecognitions = _.filter(recognitions, function(u) {
			if (!u.acf.who)
				return false;
			return u.acf.who.ID == userData.ID;
		});

		return (
			<div className="user_wrapper">
				<div className="user">
					<img src={userData.url} />
					<h2>{userData.display_name}</h2>
					<button className="add" onClick={this.addRecognition}></button>
				</div>
				<Recognitions recognitions={userRecognitions} />
			</div>
		);
	}
};