var ValuesStore = function() {
	let _users = null;
	let _recognitions = null;

	dispatcher.register(function(payload) {
		switch (payload.type) {
			case 'get-data':
				_getUsers();
				_getRecognitions();
				break;
			// case 'update-task':
			// 	_updateTask(payload.taskId, payload.changes);
			// 	break;
			case 'create-recognition':
				_createRecognition(payload.recognitionData);
				break;
		}
	}.bind(this));

	var _getUsers = function() {
		$.get('/values-board/users', function(usersResponse) {
			_users = $.parseJSON(usersResponse);
			_dataReceived();
		});
	}

	var _getRecognitions = function() {
		$.get('/values-board/recognitions', function(recognitionsResponse) {
			_recognitions = $.parseJSON(recognitionsResponse);
			_dataReceived();
		});
	}

	var _createRecognition = function(recognitionData) {
		recognitionData.author = window.current_user;

		$.post('/values-board/recognition', recognitionData, function(createdResponse) {
			const created = $.parseJSON(createdResponse);
			_recognitions.push(created);
			_dataReceived();
		});
	}

	var _dataReceived = function() {
		if (_users && _recognitions)
			_notify('data-received', {users: _users, recognitions: _recognitions});
	}

	var _notify = function(ev, data) {
		emitter.emit(ev, data);
	}
}

module.exports = new ValuesStore();